package org.implab.gradle.containers;

import javax.inject.Inject;

import org.gradle.api.file.DirectoryProperty;
import org.gradle.api.file.ProjectLayout;
import org.gradle.api.file.RegularFile;
import org.gradle.api.provider.Property;
import org.gradle.api.provider.Provider;
import org.gradle.api.provider.SetProperty;

public abstract class ComposeExtension {
    public final String COMPOSE_FILE = "compose.yaml";

    public abstract SetProperty<String> getProfiles();

    public abstract DirectoryProperty getContextDirectory();

    public abstract Property<String> getComposeFileName();

    public Provider<RegularFile> getComposeFile() {
        return getContextDirectory().file(getComposeFileName());
    }

    @Inject
    public ComposeExtension(ProjectLayout layout) {
        getContextDirectory().convention(layout.getBuildDirectory().dir("context"));
        getComposeFileName().convention(COMPOSE_FILE);
    }

}
