package org.implab.gradle.containers;

import java.util.concurrent.Callable;

import javax.inject.Inject;

import org.gradle.api.file.DirectoryProperty;
import org.gradle.api.file.RegularFileProperty;
import org.gradle.api.model.ObjectFactory;
import org.gradle.api.provider.ListProperty;
import org.gradle.api.provider.Property;
import org.gradle.api.provider.Provider;
import org.gradle.api.provider.ProviderFactory;

public interface PropertiesMixin {
    @Inject
    ObjectFactory getObjectFactory();

    @Inject
    ProviderFactory getProviders();

    default <T> Provider<T> provider(Callable<? extends T> callable) {
        return getProviders().provider(callable);
    }

    default <T> Property<T> property(Class<T> clazz) {
        return getObjectFactory().property(clazz);
    }

    default <T> ListProperty<T> listProperty(Class<T> clazz) {
        return getObjectFactory().listProperty(clazz);
    }

    default RegularFileProperty fileProperty() {
        return getObjectFactory().fileProperty();
    }

    default DirectoryProperty directoryProperty() {
        return getObjectFactory().directoryProperty();
    }

    


}
