package org.implab.gradle.containers.dsl;

import java.util.concurrent.Callable;

import org.gradle.api.provider.ListProperty;
import org.gradle.api.tasks.Input;
import org.gradle.api.tasks.Optional;
import org.implab.gradle.containers.PropertiesMixin;

import groovy.lang.Closure;

public interface OptionsMixin extends PropertiesMixin {

    @Input
    @Optional
    ListProperty<String> getOptions();

    default void option(String opt) {
        getOptions().add(opt);
    }

    default void option(Callable<String> optionProvider) {
        getOptions().add(provider(optionProvider));
    }

    default void option(Closure<String> optionProvider) {
        getOptions().add(provider(optionProvider));
    }

    default void options(String ...opts) {
        getOptions().addAll(opts);
    }

    default void options(Callable<Iterable<String>> optionsProvider) {
        getOptions().addAll(provider(optionsProvider));
    }

    default void options(Closure<Iterable<String>> optionsProvider) {
        getOptions().addAll(provider(optionsProvider));
    }
}
