package org.implab.gradle.containers.tasks;

import java.io.IOException;
import java.util.ArrayList;
import java.util.concurrent.ExecutionException;

import org.gradle.api.provider.Property;
import org.gradle.api.tasks.Internal;
import org.gradle.api.tasks.TaskAction;

public abstract class ComposeExec extends BaseExecTask implements ComposeTaskMixin {

    @Internal
    public abstract Property<String> getServiceName();

    public ComposeExec() {
        applyComposeConvention();
    }

    @TaskAction
    public void run() throws InterruptedException, ExecutionException, IOException {
        var params = new ArrayList<>(getOptions().get());

        if (isDetached())
            params.add("--detach");
        if (!getAllocateTty())
            params.add("--no-TTY");

        exec(docker().compose(this).exec(getServiceName().get(), params, getCommandLine().get()));
    }
}
