package org.implab.gradle.containers.tasks;

import java.io.File;

import org.gradle.api.provider.Property;
import org.gradle.api.provider.Provider;
import org.gradle.api.tasks.Internal;
import org.implab.gradle.containers.PropertiesMixin;
import org.implab.gradle.containers.cli.Utils;

public interface ContainerTaskMixin extends TaskServices, PropertiesMixin {
    @Internal
    Property<String> getContainerId();

    default void fromIdFile(File file) {
        getContainerId().set(provider(() -> Utils.readAll(file)));
    }

    default void fromIdFile(Provider<Object> file) {
        getContainerId().set(file.map(Utils::normalizeFile).map(Utils::readAll));
    }
}
